CREATE OR REPLACE PACKAGE ORA_EXCEL IS
   /*
    *  ORAEXCEL version 2.0.29
    *  Documentation and examples available on http://www.oraexcel.com/documentation
    *
    */
    license_key VARCHAR2(100):= '0165717427438465';
 
    /***************************************************************************
    *
    * ORA_EXCEL COPYRIGHT AND LEGAL NOTES
    *
    * This software is protected by International copyright Law. Unauthorized use, 
    * duplication, reverse engineering, any form of redistribution, or use in part 
    * or in whole other than by prior, express, printed and signed license for use
    * is subject to civil and criminal prosecution. If you have received this file 
    * in error, please notify copyright holder and destroy this and any other copies 
    * as instructed. 
    *
    * END-USER LICENSE AGREEMENT FOR ORA_EXCEL IMPORTANT PLEASE READ THE TERMS AND
    * CONDITIONS OF THIS LICENSE AGREEMENT CAREFULLY BEFORE CONTINUING WITH THIS 
    * PROGRAM INSTALL: ORA_EXCEL End-User License Agreement ("EULA") is a legal 
    * agreement between you (either an individual or a single entity) and ORA_EXCEL. 
    * For the ORA_EXCEL software product(s) identified above which may include 
    * associated software components, media, printed materials, and "online" or 
    * electronic documentation ("ORA_EXCEL"). By installing, copying, or otherwise 
    * using the SOFTWARE PRODUCT, you agree to be bound by the terms of this EULA. 
    * This license agreement represents the entire agreement concerning the program 
    * between you and ORA_EXCEL, (referred to as "licenser"), and it supersedes any 
    * prior proposal, representation, or understanding between the parties. If you 
    * do not agree to the terms of this EULA, do not install or use the SOFTWARE PRODUCT.
    * 
    * The SOFTWARE PRODUCT is protected by copyright laws and international copyright 
    * treaties, as well as other intellectual property laws and treaties. 
    * The SOFTWARE PRODUCT is licensed, not sold.
    * 
    * 1. GRANT OF LICENSE. 
    * The SOFTWARE PRODUCT is licensed as follows: 
    * (a) Installation and Use.
    * ORA_EXCEL grants you the right to install and use copies of the SOFTWARE PRODUCT 
    * on your computer running a validly licensed copy of the operating system for which 
    * the SOFTWARE PRODUCT was designed.
    * (b) Backup Copies.
    * You may also make copies of the SOFTWARE PRODUCT as may be necessary for backup 
    * and archival purposes.
    * 
    * 2. DESCRIPTION OF OTHER RIGHTS AND LIMITATIONS.
    * (a) Maintenance of Copyright Notices.
    * You must not remove or alter any copyright notices on any and all copies of the 
    * SOFTWARE PRODUCT.
    * (b) Distribution.
    * You may not distribute registered copies of the SOFTWARE PRODUCT to third parties. 
    * Evaluation versions available for download from ORA_EXCEL's websites may be freely 
    * distributed.
    * (c) Prohibition on Reverse Engineering, Decompilation, and Disassembly.
    * You may not reverse engineer, decompile, or disassemble the SOFTWARE PRODUCT, 
    * except and only to the extent that such activity is expressly permitted by 
    * applicable law notwithstanding this limitation. 
    * (d) Rental.
    * You may not rent, lease, or lend the SOFTWARE PRODUCT.
    * (e) Support Services.
    * ORA_EXCEL may provide you with support services related to the SOFTWARE PRODUCT 
    * ("Support Services"). Any supplemental software code provided to you as part of 
    * the Support Services shall be considered part of the SOFTWARE PRODUCT and subject 
    * to the terms and conditions of this EULA. 
    * (f) Compliance with Applicable Laws.
    * You must comply with all applicable laws regarding use of the SOFTWARE PRODUCT.
    * 3. TERMINATION 
    * Without prejudice to any other rights, ORA_EXCEL may terminate this EULA if you 
    * fail to comply with the terms and conditions of this EULA. In such event, you must 
    * destroy all copies of the SOFTWARE PRODUCT in your possession.
    * 4. COPYRIGHT
    * All title, including but not limited to copyrights, in and to the SOFTWARE PRODUCT 
    * and any copies thereof are owned by ORA_EXCEL or its suppliers. All title and 
    * intellectual property rights in and to the content which may be accessed through 
    * use of the SOFTWARE PRODUCT is the property of the respective content owner and 
    * may be protected by applicable copyright or other intellectual property laws and 
    * treaties. This EULA grants you no rights to use such content. All rights not 
    * expressly granted are reserved by ORA_EXCEL. 
    * 5. NO WARRANTIES
    * ORA_EXCEL expressly disclaims any warranty for the SOFTWARE PRODUCT. 
    * The SOFTWARE PRODUCT is provided 'As Is' without any express or implied warranty 
    * of any kind, including but not limited to any warranties of merchantability, 
    * noninfringement, or fitness of a particular purpose. ORA_EXCEL does not warrant 
    * or assume responsibility for the accuracy or completeness of any information, 
    * text, graphics, links or other items contained within the SOFTWARE PRODUCT. 
    * ORA_EXCEL makes no warranties respecting any harm that may be caused by the 
    * transmission of a computer virus, worm, time bomb, logic bomb, or other such 
    * computer program. ORA_EXCEL further expressly disclaims any warranty or 
    * representation to Authorized Users or to any third party.
    * 6. LIMITATION OF LIABILITY
    * In no event shall ORA_EXCEL be liable for any damages (including, without 
    * limitation, lost profits, business interruption, or lost information) rising
    * out of 'Authorized Users' use of or inability to use the SOFTWARE PRODUCT, 
    * even if ORA_EXCEL has been advised of the possibility of such damages. 
    * In no event will ORA_EXCEL be liable for loss of data or for indirect, 
    * special, incidental, consequential (including lost profit), or other 
    * damages based in contract, tort or otherwise. ORA_EXCEL shall have no 
    * liability with respect to the content of the SOFTWARE PRODUCT or any part 
    * thereof, including but not limited to errors or omissions contained therein, 
    * libel, infringements of rights of publicity, privacy, trademark rights, 
    * business interruption, personal injury, loss of privacy, moral rights or 
    * the disclosure of confidential information. 
    * 
    ****************************************************************************/
    
    TYPE "@1" IS RECORD ("@2" VARCHAR2(2), 
                                           "@3" NUMBER, 
                                           "@4" INTEGER DEFAULT 0);  
    TYPE "@5" IS TABLE OF "@1"; 
    "@6" "@5" := "@5"(); 
    
    
    TYPE "@7" IS RECORD("@8" VARCHAR2(100)); 
    TYPE "@9" IS TABLE OF "@7"; 
    "@10" "@9" := "@9"(); 
    
    TYPE "@11" IS RECORD ("@12" VARCHAR2(1000), 
                                    "@13" VARCHAR2(10)); 
    TYPE "@14" IS table OF "@11"; 
    "@26" "@14" := "@14"(); 
    
    TYPE "@728" IS RECORD ("@12" VARCHAR2(1000), 
                                             "@13" VARCHAR2(10)); 
    TYPE "@729" IS table OF "@728"; 
    "@730" "@729" := "@729"(); 
    
    
    
    TYPE "@15" IS RECORD ("@16" VARCHAR2(1000), 
                                  "@17" VARCHAR2(30), 
                                  "@18" NUMBER, 
                                  "@19" NUMBER, 
                                  "@20" INTEGER, 
                                  "@21" INTEGER, 
                                  "@22" VARCHAR2(10)); 
    TYPE "@23" IS TABLE OF "@15"; 
    "@27" "@23" := "@23"(); 
    
    TYPE "@24" IS TABLE OF CLOB; 
    "@25" "@24" := "@24"(); 
    
     
    TYPE "@28" IS RECORD ("@29" VARCHAR2(20), 
                                      "@30" VARCHAR2(1), 
                                      "@31" VARCHAR2(100), 
                                      "@32" PLS_INTEGER := 0, 
                                      "@33" PLS_INTEGER := 0,  
                                      "@34" PLS_INTEGER := 0,  
                                      "@35" PLS_INTEGER := 0,  
                                      "@36" PLS_INTEGER := 0, 
                                      "@37" PLS_INTEGER, 
                                      "@38" VARCHAR2(4000),
                                      "@39" BOOLEAN := FALSE, 
                                      "@40" BOOLEAN := FALSE, 
                                      "@41" BOOLEAN := FALSE, 
                                      "@42" VARCHAR2(8), 
                                      "@43" VARCHAR2(8), 
                                      "@44" VARCHAR2(1), 
                                      "@45" VARCHAR2(1), 
                                      "@46" BOOLEAN DEFAULT FALSE, 
                                      "@47" BOOLEAN DEFAULT FALSE, 
                                      "@48" VARCHAR2(6), 
                                      "@49" VARCHAR2(8), 
                                      "@50" BOOLEAN DEFAULT FALSE, 
                                      "@51" VARCHAR2(6), 
                                      "@52" VARCHAR2(8), 
                                      "@53" BOOLEAN DEFAULT FALSE, 
                                      "@54" VARCHAR2(6), 
                                      "@55" VARCHAR2(8), 
                                      "@56" BOOLEAN DEFAULT FALSE, 
                                      "@57" VARCHAR2(6), 
                                      "@58" VARCHAR2(8), 
                                      "@59" VARCHAR2(10), 
                                      "@60" VARCHAR2(8), 
                                      "@61" BOOLEAN DEFAULT FALSE, 
                                      "@62" BOOLEAN, 
                                      "@63" VARCHAR2(2),  
                                      "@64" VARCHAR2(2),  
                                      "@65" PLS_INTEGER,  
                                      "@66" BOOLEAN, 
                                      "@67" PLS_INTEGER := 0, 
                                      "@68" INTEGER := 0, 
                                      "@69" INTEGER := 0, 
                                      "@70" INTEGER := 0,  
                                      "@370" VARCHAR2(4000)); 
    "@71" "@28";   
    TYPE "@72" IS TABLE OF "@28" INDEX BY PLS_INTEGER; 
    
    "@73" "@72"; 
    
    
    TYPE "@74" IS RECORD ("@75" VARCHAR2(32), 
                                "@76" CLOB, 
                                "@77" "@24", 
                                "@78" PLS_INTEGER, 
                                "@79" PLS_INTEGER,
                                "@180" "@5", 
                                "@181" "@9", 
                                "@80" BOOLEAN DEFAULT FALSE,
                                "@81" NUMBER, 
                                "@82" NUMBER, 
                                "@83" NUMBER,  
                                "@84" NUMBER,  
                                "@85" NUMBER,  
                                "@86" NUMBER,  
                                "@87" VARCHAR2(10), 
                                "@88" INTEGER, 
                                "@89" VARCHAR2(1000), 
                                "@92" VARCHAR2(1000),   
                                "@182" "@14", 
                                "@731" "@729", 
                                "@183" "@23", 
                                "@90" VARCHAR2(20),  
                                "@91" VARCHAR2(20), 
                                "@93" "@72", 
                                "@94" NUMBER, 
                                "@95" BOOLEAN);  
    TYPE "@96" IS TABLE OF "@74"; 
    "@97" "@96" := "@96"(); 
    
    
    
    TYPE "@98" IS RECORD("@184" VARCHAR(60)); 
    TYPE "@99" IS TABLE OF "@98"; 
    "@100" "@99" := "@99"(); 
    
    
    TYPE "@101" IS RECORD ("@102" PLS_INTEGER, 
                                "@103" PLS_INTEGER, 
                                "@104" PLS_INTEGER,  
                                "@105" PLS_INTEGER,  
                                "@106" PLS_INTEGER, 
                                "@107" VARCHAR2(1), 
                                "@108" VARCHAR2(1), 
                                "@109" BOOLEAN, 
                                "@110" INTEGER, 
                                "@111" INTEGER, 
                                "@112" INTEGER); 
    TYPE "@113" IS table OF "@101"; 
    "@114" "@113" := "@113"(); 
    
    
    
    
    TYPE "@115" IS RECORD ("@116" PLS_INTEGER, 
                               "@117" VARCHAR2(100), 
                               "@118" BOOLEAN := FALSE, 
                               "@119" BOOLEAN := FALSE, 
                               "@120" BOOLEAN := FALSE, 
                               "@121" VARCHAR2(8)); 
    TYPE "@122" IS table OF "@115"; 
    "@123" "@122" := "@122"(); 
    
    
    TYPE "@124" IS RECORD ("@125" VARCHAR2(10), 
                               "@126" VARCHAR2(8));
    TYPE "@127" IS TABLE OF "@124"; 
    "@128" "@127" := "@127"();
                               
    
    
    TYPE "@129" IS RECORD ("@130" PLS_INTEGER,
                                      "@131" VARCHAR2(100));
    
    TYPE "@132" IS RECORD ("@133" BOOLEAN DEFAULT FALSE,
                                 "@134" VARCHAR2(6),
                                 "@135" VARCHAR2(8),
                                 "@136" BOOLEAN DEFAULT FALSE,
                                 "@137" VARCHAR2(6),
                                 "@138" VARCHAR2(8),
                                 "@139" BOOLEAN DEFAULT FALSE,
                                 "@140" VARCHAR2(6),
                                 "@141" VARCHAR2(8),
                                 "@142" BOOLEAN DEFAULT FALSE,
                                 "@143" VARCHAR2(6),
                                 "@144" VARCHAR2(8),
                                 "@145" VARCHAR2(10),
                                 "@146" VARCHAR2(8)); 
    TYPE "@147" IS TABLE OF "@132";
    "@148" "@147" := "@147"();
    
    
    TYPE "@149" IS TABLE OF CLOB;
    "@150" "@149" := "@149"();
        
    TYPE "@753" IS RECORD ("@752" VARCHAR2(20), 
                                "@754" VARCHAR2(100), 
                                "@755" PLS_INTEGER, 
                                "@38" VARCHAR2(4000),
                                "@39" BOOLEAN := FALSE, 
                                "@40" BOOLEAN := FALSE, 
                                "@41" BOOLEAN := FALSE, 
                                "@42" VARCHAR2(8), 
                                "@43" VARCHAR2(8), 
                                "@44" VARCHAR2(20), 
                                "@45" VARCHAR2(20), 
                                "@47" BOOLEAN DEFAULT FALSE, 
                                "@48" VARCHAR2(6), 
                                "@49" VARCHAR2(8), 
                                "@50" BOOLEAN DEFAULT FALSE, 
                                "@51" VARCHAR2(6), 
                                "@52" VARCHAR2(8), 
                                "@53" BOOLEAN DEFAULT FALSE, 
                                "@54" VARCHAR2(6), 
                                "@55" VARCHAR2(8), 
                                "@56" BOOLEAN DEFAULT FALSE, 
                                "@57" VARCHAR2(6), 
                                "@58" VARCHAR2(8), 
                                "@756" BOOLEAN, 
                                "@59" VARCHAR2(10), 
                                "@60" VARCHAR2(8), 
                                "@61" BOOLEAN DEFAULT FALSE, 
                                "@67" VARCHAR2(60) := NULL, 
                                "@68" INTEGER := 0, 
                                "@69" INTEGER := 0, 
                                "@70" INTEGER := 0); 
                                
                                   
    TYPE "@757" IS TABLE OF "@753" INDEX BY VARCHAR2(50); 
                        
                                
    
    
    TYPE "@151" IS RECORD ("@152" "@96", 
                                   "@153" CLOB,
                                   "@154" "@149",
                                   "@155" PLS_INTEGER,
                                   "@156" "@99", 
                                   "@157" "@113",
                                   "@158" "@122", 
                                   "@159" "@129",
                                   "@160" "@127",
                                   "@161" "@147",
                                   "@162" BOOLEAN,
                                   "@732" BOOLEAN,
                                   "@582" VARCHAR2(1000), 
                                   "@758" "@757"); 
    TYPE "@163" IS TABLE OF "@151";
    "@164" "@163";
    "@165" "@163" := "@163"();
   
    
    doc_id PLS_INTEGER := 0;
    current_doc_id PLS_INTEGER;
    current_sheet_id PLS_INTEGER; 
    current_row_id PLS_INTEGER;
    "@167" CLOB;
    "@168" PLS_INTEGER;
    "@169" BOOLEAN := FALSE;
    
    
    "@170" PLS_INTEGER;
    "@171" VARCHAR2(20);
    "@172" VARCHAR2(20);
    "@173" PLS_INTEGER;
    
    "@270" NUMBER := 4000;
    "@271" NUMBER := 32767;
    
    TYPE "@174" IS TABLE OF VARCHAR2(32767) INDEX BY PLS_INTEGER;
    "@175" "@174";
    
    TYPE "@176" IS TABLE OF VARCHAR2(32767) INDEX BY PLS_INTEGER;
    "@177" "@176";
    
    TYPE "@178" IS TABLE OF VARCHAR2(32767) INDEX BY PLS_INTEGER;
    "@179" "@178";
    "@300" BLOB := EMPTY_BLOB(); 
    "@301" CLOB := EMPTY_CLOB(); 
    "@302" CLOB := EMPTY_CLOB();
    
    TYPE cell_value_type IS RECORD(value VARCHAR2(32767),
                                   varchar2_value VARCHAR2(32767),
                                   number_value NUMBER,
                                   date_value DATE,
                                   type VARCHAR2(1));
    "@309" INTEGER;
    "@310" CLOB;
    TYPE "@311" IS TABLE OF VARCHAR2(1) INDEX BY PLS_INTEGER;
    "@312" "@311";
    "@313" "@311";  
    "@314" VARCHAR2(4);
    "@315" VARCHAR2(30);
    "@452" INTEGER;
    
    /***************************************************************************
    * Description: Creates new instance of excel document, initializes space 
    *  storage and prepares parameters
    *
    * Input Parameters: 
    *   - no input parameters
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - doc_id [unique identifier of document]
    *
    ****************************************************************************/
    FUNCTION new_document 
    RETURN PLS_INTEGER;
    
    
    
    /***************************************************************************
    * Description: Wrapper procedure of new_document function
    *
    * Input Parameters: 
    *   - no input parameters
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/
    PROCEDURE new_document;
    
    
    
    /***************************************************************************
    * Description: Adds new sheet to document
    *
    * Input Parameters: 
    *   - sheet_name [sheet name that will be displayed on sheet tab]
    *   - doc_id     [unique identificator od document]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - sheet_id  [unique identificator of sheet within document]
    *
    ****************************************************************************/
    FUNCTION add_sheet(sheet_name VARCHAR2, 
                       doc_id PLS_INTEGER DEFAULT current_doc_id) 
    RETURN PLS_INTEGER;
    
    
    
    /***************************************************************************
    * Description: Wrapper procedure of add_sheet function
    *
    * Input Parameters: 
    *   - sheet_name [sheet name that will be displayed on sheet tab]
    *   - doc_id     [unique identificator of document]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/
    PROCEDURE add_sheet(sheet_name VARCHAR2, 
                        doc_id PLS_INTEGER DEFAULT current_doc_id);
    
         
                       
    /***************************************************************************
    * Description: Adds row to current or specified sheet
    *
    * Input Parameters: 
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - row_id    [unique identificator of row within specified sheed and document]
    *
    ****************************************************************************/
    FUNCTION add_row(doc_id PLS_INTEGER DEFAULT current_doc_id, 
                     sheet_id PLS_INTEGER DEFAULT current_sheet_id) RETURN PLS_INTEGER; 
    
         
                
    /***************************************************************************
    * Description: Wrapper procedure for add_row function
    *
    * Input Parameters: 
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                
    PROCEDURE add_row(doc_id PLS_INTEGER DEFAULT current_doc_id, 
                      sheet_id PLS_INTEGER DEFAULT current_sheet_id);
    
      
    
    /***************************************************************************
    * Description: Sets height of speficied row
    *
    * Input Parameters: 
    *   - height     [height of the row]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                 
    PROCEDURE set_row_height(height NUMBER, 
                             doc_id PLS_INTEGER DEFAULT current_doc_id, 
                             sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                             row_id PLS_INTEGER DEFAULT current_row_id); 
    
                                                      
    /***************************************************************************
    * Description: Sets value of numeric cell
    *
    * Input Parameters: 
    *   - name       [name of the cell where value will be added]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_value (name VARCHAR2, 
                              value NUMBER, 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                              row_id PLS_INTEGER DEFAULT current_row_id);
    
         
                                
    /***************************************************************************
    * Description: Sets value of string cell
    *
    * Input Parameters: 
    *   - name       [name of the cell where value will be added]
    *   - value      [date value that will be set to the cell]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_value (name VARCHAR2, 
                              value VARCHAR2, 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                              row_id PLS_INTEGER DEFAULT current_row_id); 
    
                                   
                              
    /***************************************************************************
    * Description: Sets value of date cell
    *
    * Input Parameters: 
    *   - name       [name of the cell where value will be added]
    *   - value      [date value that will be set to the cell]
    *   - doc_id     [unique identificator of document
    *   - sheet_id   [unique identificator of sheet
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_value (name VARCHAR2, 
                              value DATE, 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                              row_id PLS_INTEGER DEFAULT current_row_id); 
    
                                   
                              
    /***************************************************************************
    * Description: Sets value of big string cell (CLOB)
    *
    * Input Parameters: 
    *   - name       [name of the cell where value will be added]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                  
    PROCEDURE set_cell_value (name VARCHAR2, 
                              value CLOB, 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                              row_id PLS_INTEGER DEFAULT current_row_id);  
    
                                   
                              
    /***************************************************************************
    * Description: Sets format of the cell
    *
    * Input Parameters: 
    *   - cell_name  [name of the cell on which format will be applied]
    *   - format     [format mask that will be applied to the cell, same as custom format in Excel]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                                                              
    PROCEDURE set_cell_format (cell_name VARCHAR2, 
                               format VARCHAR2, 
                               doc_id PLS_INTEGER DEFAULT current_doc_id, 
                               sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                               row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Generates Excel document and stores it in BLOB variable
    *
    * Input Parameters: 
    *   - blob_file  [BLOB variable where generated Excel will be stored]
    *   - doc_id     [unique identificator of document]
    *
    * Output Parameters: 
    *   - blob_file  [BLOB variable where generated Excel will be stored]
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                                                                                                                                                        
    PROCEDURE save_to_blob(blob_file IN OUT BLOB, 
                           doc_id PLS_INTEGER DEFAULT current_doc_id);                                              
    
                                   
                              
    /***************************************************************************
    * Description: Sets font family of the cell
    *
    * Input Parameters: 
    *   - cell_name  [name of the cell on which format will be applied]
    *   - font_name  [font family which will be applied to the cell ex. Arial]
    *   - font_size  [size that will be applied to the font for specified cell]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_font(cell_name VARCHAR2, 
                            font_name VARCHAR2, 
                            font_size PLS_INTEGER DEFAULT 10, 
                            doc_id PLS_INTEGER DEFAULT current_doc_id, 
                            sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                            row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets default font family for whole document
    *
    * Input Parameters: 
    *   - font_name  [font family which will be applied to whole document ex. Arial]
    *   - font_size  [size that will be applied to the font for whole document]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_default_font (font_name VARCHAR2 DEFAULT 'Calibri', 
                                font_size PLS_INTEGER DEFAULT 11, 
                                doc_id PLS_INTEGER DEFAULT current_doc_id); 
    
                                   
                              
    /***************************************************************************
    * Description: Sets cell type to bold
    *
    * Input Parameters: 
    *   - name       [name of cell which content will be bolded]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_bold(name VARCHAR2, 
                            doc_id PLS_INTEGER DEFAULT current_doc_id, 
                            sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                            row_id PLS_INTEGER DEFAULT current_row_id); 
    
                                   
                              
    /***************************************************************************
    * Description: Sets cell stype to italic
    *
    * Input Parameters: 
    *   - name       [name of cell which content will be formated to italic]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_italic(name VARCHAR2, 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                              row_id PLS_INTEGER DEFAULT current_row_id);                                                              
    
                                   
                              
    /***************************************************************************
    * Description: Sets cell stype to underline
    *
    * Input Parameters: 
    *   - name       [name of cell which content will be underline]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_underline(name VARCHAR2, 
                                 doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                 sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                 row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets color of font within cell
    *
    * Input Parameters: 
    *   - name       [name of cell which font will be colored]
    *   - color      [font color in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                              
    PROCEDURE set_cell_color(name VARCHAR2, 
                             color VARCHAR2, 
                             doc_id PLS_INTEGER DEFAULT current_doc_id, 
                             sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                             row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets background color of cell
    *
    * Input Parameters: 
    *   - name       [name of cell which background will be colored]
    *   - color      [background color in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                                   
    PROCEDURE set_cell_bg_color(name VARCHAR2, 
                                color VARCHAR2, 
                                doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                row_id PLS_INTEGER DEFAULT current_row_id);   
    
                                   
                              
    /***************************************************************************
    * Description: Sets left side horizontal alignement of cell 
    *
    * Input Parameters: 
    *   - name       [name of cell content will be placed to left side of column]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_align_left(name VARCHAR2, 
                                 doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                 sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                 row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets horizontal alignement of cell to center  
    *
    * Input Parameters: 
    *   - name       [name of cell content will be centered]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_align_center(name VARCHAR2, 
                                    doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                    sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                    row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets horizontal alignement of cell to right  
    *
    * Input Parameters: 
    *   - name       [name of cell content will be placed to right side of column]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_align_right(name VARCHAR2, 
                                   doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                   row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Sets vertical alignement of cell to top
    *
    * Input Parameters: 
    *   - name       [name of cell content will be placed to the top]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_vert_align_top(name VARCHAR2, 
                                      doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                      sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                      row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                    
    /***************************************************************************
    * Description: Sets vertical alignement of cell to middle
    *
    * Input Parameters: 
    *   - name       [name of cell content will be placed in the middle]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_vert_align_middle(name VARCHAR2, 
                                         doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                         sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                         row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets vertical alignement of cell to bottom
    *
    * Input Parameters: 
    *   - name       [name of cell content will be placed to the bottom]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_vert_align_bottom(name VARCHAR2, 
                                         doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                         sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                         row_id PLS_INTEGER DEFAULT current_row_id);
    
    
                                             
    /***************************************************************************
    * Description: Sets width of the column
    *
    * Input Parameters: 
    *   - name       [name of the column which width will be set to specified value]
    *   - width      [width of column]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_column_width(name VARCHAR2, 
                               width NUMBER, 
                               doc_id PLS_INTEGER DEFAULT current_doc_id, 
                               sheet_id PLS_INTEGER DEFAULT current_sheet_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets top border of the cell
    *
    * Input Parameters: 
    *   - name       [name of cell on which top border will be set]
    *   - style      [style of the border:  thin, thick, double]
    *   - color      [color of border in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_border_top(name VARCHAR2, 
                                  style VARCHAR2 DEFAULT 'thin', 
                                  color VARCHAR2 DEFAULT '00000000', 
                                  doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                  sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                  row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets bottom border of the cell
    *
    * Input Parameters: 
    *   - name       [name of cell on which bottom border will be set]
    *   - style      [style of the border:  thin, thick, double]
    *   - color      [color of border in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_border_bottom(name VARCHAR2, 
                                     style VARCHAR2 DEFAULT 'thin', 
                                     color VARCHAR2 DEFAULT '00000000', 
                                     doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                     sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                     row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets left border of the cell
    *
    * Input Parameters: 
    *   - name       [name of cell on which left border will be set]
    *   - style      [style of the border:  thin, thick, double]
    *   - color      [color of border in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_border_left(name VARCHAR2, 
                                   style VARCHAR2 DEFAULT 'thin', 
                                   color VARCHAR2 DEFAULT '00000000', 
                                   doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                   row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets right border of the cell
    *
    * Input Parameters: 
    *   - name       [name of cell on which right border will be set]
    *   - style      [style of the border:  thin, thick, double]
    *   - color      [color of border in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_border_right(name VARCHAR2, 
                                    style VARCHAR2 DEFAULT 'thin', 
                                    color VARCHAR2 DEFAULT '00000000', 
                                    doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                    sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                    row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Sets border of the cell
    *
    * Input Parameters: 
    *   - name       [name of cell on which border will be set]
    *   - style      [style of the border:  thin, thick, double]
    *   - color      [color of border in RRGGBB hex format RR - red, GG - green, BB blue]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_border(name VARCHAR2, 
                              style VARCHAR2 DEFAULT 'thin', 
                              color VARCHAR2 DEFAULT '00000000', 
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                              row_id PLS_INTEGER DEFAULT current_row_id);                                 
    
                                   
                                                                       
    /***************************************************************************
    * Description: Fetches data with speified query and place results on specified
    * or current sheet
    *
    * Input Parameters: 
    *   - query             [SQL query whih result will be added to sheet]
    *   - show_column_names [parameter to hide or show column names from SQL query, boolean values TRUE or FALSE]    
    *   - doc_id            [unique identificator of document]
    *   - sheet_id          [unique identificator of sheet]    
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                        
    PROCEDURE query_to_sheet(query CLOB, 
                             show_column_names BOOLEAN DEFAULT TRUE, 
                             doc_id PLS_INTEGER DEFAULT current_doc_id, 
                             sheet_id PLS_INTEGER DEFAULT current_sheet_id);                                                              
    
                                   
                                                                       
    /***************************************************************************
    * Description: Generates Excel document and saves it to physical file in Oracle directory
    *
    * Input Parameters: 
    *   - directory_name [name of Oracle directory where Excel document will be saved]
    *   - file_name      [file name of generated Excel document]
    *   - doc_id         [unique identificator of document]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE save_to_file(directory_name VARCHAR2, 
                           file_name VARCHAR2, 
                           doc_id PLS_INTEGER DEFAULT current_doc_id);   
    
                                   
                                                                       
    /***************************************************************************
    * Description: Merges cells horizontaly within specified range
    *
    * Input Parameters: 
    *   - cell_from  [name of cell from merge will be started, name example: A1]
    *   - cell_to    [name of cell to where merge will finis, name example: C1]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE merge_cells (cell_from VARCHAR2, 
                           cell_to VARCHAR2, 
                           doc_id PLS_INTEGER DEFAULT current_doc_id, 
                           sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                           row_id PLS_INTEGER DEFAULT current_row_id);                                                                                                                                                        
    
                                   
                                                                       
    /***************************************************************************
    * Description: Wraps text within cell
    *
    * Input Parameters: 
    *   - name       [name of cell which text will be wrapped]
    *   - doc_id     [unique identificator of document on which is located sheet 
    *                 where is lcaterd row with cell which conted will be wrapped]
    *   - sheet_id   [unique identificator of sheet on which is located row
    *                 row with cell which conted will be wrapped]
    *   - row_id     [unique identificator of row on which cell will be merged]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_wrap_text (name VARCHAR2, 
                                  doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                  sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                  row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                                                                       
    /***************************************************************************
    * Description: Merges cells vertically within specified range
    *
    * Input Parameters: 
    *   - cell_from  [name of cell from merge will be started, name example: A1]
    *   - cell_to    [name of cell to where merge will finis, name example: C1]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE merge_rows (cell_from VARCHAR2, 
                          cell_to PLS_INTEGER, 
                          doc_id PLS_INTEGER DEFAULT current_doc_id, 
                          sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                          row_id PLS_INTEGER DEFAULT current_row_id);
    
    
                                                                
    /***************************************************************************
    * Description: Sets cell formula
    *
    * Input Parameters: 
    *   - name       [name of the cell where value will be added]
    *   - formula    [formula that will be used to calculate cell value]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
        PROCEDURE set_cell_formula(name VARCHAR2, 
                                  formula VARCHAR2, 
                                  doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                  sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                                  row_id PLS_INTEGER DEFAULT current_row_id);
    
                                   
                              
    /***************************************************************************
    * Description: Rotates text to a diagonal angle
    *
    * Input Parameters: 
    *   - name       [name of cell content will be centered]
    *   - degrees    [degree from 90 to 180 which will be used to rotate text]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_rotate_text(name VARCHAR2,
                                   degrees INTEGER, 
                                   doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                   row_id PLS_INTEGER DEFAULT current_row_id);
    
    
                                        
    /***************************************************************************
    * Description: Initiates download of generated excel file using DAD
    *
    * Input Parameters: 
    *   - file_name      [file name that will be suggested when download dialog appears]
    *   - doc_id         [unique identificator of document]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE download_file(file_name VARCHAR2, 
                            doc_id PLS_INTEGER DEFAULT current_doc_id);   
    
    
    
    /***************************************************************************
    * Description: Sets margins of sheet
    *
    * Input Parameters: 
    *   - left_margin     [margin size on the left side of sheet]
    *   - right_margin    [margin size on the right side of sheet]
    *   - top_margin      [margin size on the top side of sheet]
    *   - bottom_margin   [margin size on the bottom side of sheet]
    *   - header_margin   [margin size on the header side of sheet]
    *   - footer_margin   [margin size on the footer side of sheet]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_sheet_margins(left_margin NUMBER,
                                right_margin NUMBER, 
                                top_margin NUMBER,
                                bottom_margin NUMBER,
                                header_margin NUMBER,
                                footer_margin NUMBER, 
                                sheet_id PLS_INTEGER DEFAULT current_sheet_id);
    
    
    /***************************************************************************
    * Description: Sets sheet orientation to landscape
    *
    * Input Parameters: 
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_sheet_landscape(sheet_id PLS_INTEGER DEFAULT current_sheet_id); 
    
    
    /***************************************************************************
    * Description: Sets sheet paper size
    *
    * Input Parameters: 
    *   - paper_size [paper size of sheet]
    *                Possible values: 
    *                   1 - Letter (8-1/2 in. x 11 in.)
    *                   2 - Letter Small (8-1/2 in. x 11 in.)
    *                   3 - Tabloid (11 in. x 17 in.)
    *                   4 - Ledger (17 in. x 11 in.)
    *                   5 - Legal (8-1/2 in. x 14 in.)
    *                   6 - Statement (5-1/2 in. x 8-1/2 in.)
    *                   7 - Executive (7-1/2 in. x 10-1/2 in.)
    *                   8 - A3 (297 mm x 420 mm)
    *                   9 - A4 (210 mm x 297 mm)
    *                   10 - A4 Small (210 mm x 297 mm)
    *                   11 - A5 (148 mm x 210 mm)
    *                   12 - B4 (250 mm x 354 mm)
    *                   13 - A5 (148 mm x 210 mm)
    *                   14 - Folio (8-1/2 in. x 13 in.)
    *                   15 - Quarto (215 mm x 275 mm)
    *                   16 - 10 in. x 14 in.
    *                   17 - 11 in. x 17 in.
    *                   18 - Note (8-1/2 in. x 11 in.)
    *                   19 - Envelope #9 (3-7/8 in. x 8-7/8 in.)
    *                   20 - Envelope #10 (4-1/8 in. x 9-1/2 in.)
    *                   21 - Envelope #11 (4-1/2 in. x 10-3/8 in.)
    *                   22 - Envelope #12 (4-1/2 in. x 11 in.)
    *                   23 - Envelope #14 (5 in. x 11-1/2 in.)
    *                   24 - C size sheet
    *                   25 - D size sheet
    *                   26 - E size sheet
    *                   27 - Envelope DL (110 mm x 220 mm)
    *                   28 - Envelope C5 (162 mm x 229 mm)
    *                   29 - Envelope C3 (324 mm x 458 mm)
    *                   30 - Envelope C4 (229 mm x 324 mm)
    *                   31 - Envelope C6 (114 mm x 162 mm)
    *                   32 - Envelope C65 (114 mm x 229 mm)
    *                   33 - Envelope B4 (250 mm x 353 mm)
    *                   34 - Envelope B5 (176 mm x 250 mm)
    *                   35 - Envelope B6 (176 mm x 125 mm)
    *                   36 - Envelope (110 mm x 230 mm)
    *                   37 - Envelope Monarch (3-7/8 in. x 7-1/2 in.)
    *                   38 - Envelope (3-5/8 in. x 6-1/2 in.)
    *                   39 - U.S. Standard Fanfold (14-7/8 in. x 11 in.)
    *                   40 - German Legal Fanfold (8-1/2 in. x 13 in.)
    *                   41 - German Legal Fanfold (8-1/2 in. x 13 in.)
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_sheet_paper_size(paper_size INTEGER, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id);
    
    
    /***************************************************************************
    * Description: Sets sheet header text
    *
    * Input Parameters: 
    *   - header_text [text that will be displayed on sheets header, limited to 1000 characters]
    *   - sheet_id    [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_sheet_header_text(header_text VARCHAR2,
                                    sheet_id PLS_INTEGER DEFAULT current_sheet_id); 
    
    
    /***************************************************************************
    * Description: Sets sheet footer text
    *
    * Input Parameters: 
    *   - header_text [text that will be displayed on sheets footer, limited to 1000 characters]
    *   - sheet_id    [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_sheet_footer_text(footer_text VARCHAR2,
                                    sheet_id PLS_INTEGER DEFAULT current_sheet_id); 
    
    /***************************************************************************
    * Description: Sets hyperlink for cell
    *
    * Input Parameters: 
    *   - name       [cell name]
    *   - hyperlink  [hyperlink that will be set on cell]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                 
    PROCEDURE set_cell_hyperlink(name VARCHAR2, 
                                 hyperlink VARCHAR2,
                                 doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                 sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                 row_id PLS_INTEGER DEFAULT current_row_id); 
    
    /***************************************************************************
    * Description: Sets hyperlink within document, to same or another sheet and 
    *              to cell within sheet
    *
    * Input Parameters: 
    *   - name       [cell name]
    *   - hyperlink  [hyperlink that will be set on cell, example Sheet1!A1 will
    *                 link to sheet with name Sheet1 and to cell A1 within that
    *                 sheet - if sheet name containst spaces it must be enclosed
    *                 with sigle quotes example: '''My Sheet1''!A1' ]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                 
    PROCEDURE set_cell_internal_hyperlink(name VARCHAR2, 
                                          hyperlink VARCHAR2,
                                          doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                          sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                          row_id PLS_INTEGER DEFAULT current_row_id); 
    
                                         
    /***************************************************************************
    * Description: Sets left indent within the cell
    *
    * Input Parameters: 
    *   - name       [name of cell content will be indented from the left side]
    *   - indent     [number of indent from left site of cell]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_indent_left(name VARCHAR2, 
                                   indent INTEGER,
                                   doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                   row_id PLS_INTEGER DEFAULT current_row_id);
    
    
    /***************************************************************************
    * Description: Sets right indent within the cell
    *
    * Input Parameters: 
    *   - name       [name of cell content will be indented from the right side]
    *   - indent     [number of indent from left site of cell]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE set_cell_indent_right(name VARCHAR2, 
                                   indent INTEGER,
                                   doc_id PLS_INTEGER DEFAULT current_doc_id, 
                                   sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                                   row_id PLS_INTEGER DEFAULT current_row_id);
    
    
    /***************************************************************************
    * Description: Sets comment text and author name for cell
    *
    * Input Parameters: 
    *   - name                [cell name]
    *   - author              [name of the autor of the comment]
    *   - comment_text        [comment text for the cell]
    *   - comment_box_width   [width of comment box]
    *   - comment_box_height  [height of comment box]
    *   - doc_id              [unique identificator of document]
    *   - sheet_id            [unique identificator of sheet]
    *   - row_id              [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                 
    PROCEDURE set_cell_comment(name VARCHAR2, 
                               autohr VARCHAR2,
                               comment_text VARCHAR2,
                               comment_box_width NUMBER DEFAULT 100,
                               comment_box_height NUMBER DEFAULT 60,
                               doc_id PLS_INTEGER DEFAULT current_doc_id, 
                               sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                               row_id PLS_INTEGER DEFAULT current_row_id); 
    
    
    /***************************************************************************
    * Description: Hides column
    *
    * Input Parameters: 
    *   - name       [name of the column which will be hidden]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/ 
    PROCEDURE hide_column(name VARCHAR2,  
                          doc_id PLS_INTEGER DEFAULT current_doc_id, 
                          sheet_id PLS_INTEGER DEFAULT current_sheet_id);
    
    
    /***************************************************************************
    * Description: Hides row
    *
    * Input Parameters: 
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *   - row_id     [unique identificator of row]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/                 
    PROCEDURE hide_row(doc_id PLS_INTEGER DEFAULT current_doc_id, 
                       sheet_id PLS_INTEGER DEFAULT current_sheet_id, 
                       row_id PLS_INTEGER DEFAULT current_row_id); 
    
    
    /***************************************************************************
    * Description: Sets column auto filter between defined columns range
    *
    * Input Parameters: 
    *   - cell_from  [cell name with row number from which auto filter will start, example: A1]
    *   - cell_to    [cell name with row number where auto filter will end, example: A5]
    *   - doc_id     [unique identificator of document]
    *   - sheet_id   [unique identificator of sheet]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/    
    PROCEDURE set_cells_filter(cell_from VARCHAR2, 
                              cell_to VARCHAR2,
                              doc_id PLS_INTEGER DEFAULT current_doc_id, 
                              sheet_id PLS_INTEGER DEFAULT current_sheet_id); 
    
    
    /***************************************************************************
    * Description: Opens Excel file for reading
    *
    * Input Parameters: 
    *   - directory_name [name of Oracle directory from where Excel document will be opened]
    *   - file_name      [file name of Excel document]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
     PROCEDURE open_document(directory_name VARCHAR2, 
                             file_name VARCHAR2);
    
    
    /***************************************************************************
    * Description: Release memory for currently opened document
    *
    * Input Parameters:
    *   - no imput parameters 
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
     PROCEDURE close_document;
    
    
    /***************************************************************************
    * Description: Loads sheet from opened document
    *
    * Input Parameters:
    *   - sheet_name - [name of sheet case isensitive]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
    PROCEDURE open_sheet(sheet_name VARCHAR2);
    
    
    /***************************************************************************
    * Description: Loads sheet from opened document
    *
    * Input Parameters:
    *   - sheet_id - [numberic index od sheet (ex. 1 = first sheet, 2 = second sheet ...)]
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
    PROCEDURE open_sheet(sheet_id PLS_INTEGER);
    
    /***************************************************************************
    * Description: Returns cell value
    *
    * Input Parameters:
    *   - cell_name - [cell name which conted will be returned (ex. A1)] 
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - cell value type
    *       - varchar2_value  - cell value converted to varchar2 type 
    *       - varchar2_number - cell value converted to number type
    *       - varchar2_date   - cell value converted to date type
    *
    ****************************************************************************/      
    
    FUNCTION get_cell_value(cell_name VARCHAR2) RETURN cell_value_type;
    
    
    /***************************************************************************
    * Description: Returns last row number from loaded sheet
    *
    * Input Parameters:
    *   - no input parameters
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - last row number
    *
    ****************************************************************************/ 
    FUNCTION get_last_row RETURN INTEGER;
    
    
    /***************************************************************************
    * Description: Set 1904 date system, the first day that is supported is 
    *              January 1, 1904
    *
    * Input Parameters:
    *   - no input parameters
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/     
    PROCEDURE set_1904_date_system;
    
    
    /***************************************************************************
    * Description: Set 1900 date system, the first day that is supported is 
    *              January 1, 1900
    *
    * Input Parameters:
    *   - no input parameters
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/     
    PROCEDURE set_1900_date_system;
    
    /***************************************************************************
    * Description: Set document author property to custom value
    *
    * Input Parameters:
    *   - author - author name
    *   - doc_id - unique identificator of document
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
    
    PROCEDURE set_document_author(author VARCHAR2, doc_id PLS_INTEGER DEFAULT current_doc_id);
              
    
    /***************************************************************************
    * Description: Add style to current docuemnt
    *
    * Input Parameters:
    *   - style_name            - style name used as referece to apply to cell
    *   - font_name             - font name examples: 'Tahoma', 'Arial', 'Times New Roman'
    *   - font_size             - font size, default 11
    *   - formula               - cell formula
    *   - bold                  - bold cell content
    *   - italic                - italic cell content
    *   - underline             - underline cell content
    *   - color                 - text color in hex, example: red = FF0000
    *   - bg_color              - cell background color in hex, example: grey = CCCCCC
    *   - horizontal_align      - horizontal text alignment, values: 'left', 'center', 'right'
    *   - vertical_align        - vertical text alignment, value: 'top', 'middle', 'bottom'
    *   - border_top            - show cell top border, values: TRUE, FALSE
    *   - border_top_style      - top border style, values: 'thin', 'thick', 'double'
    *   - border_top_color      - top border color in hex, example green = 00FF00
    *   - border_bottom         - show cell bottom border, values: TRUE, FALSE
    *   - border_bottom_style   - bottom border style, values: 'thin', 'thick', 'double'
    *   - border_bottom_color   - bottom border color in hex, example green = 00FF00
    *   - border_left           - show cell left border, values: TRUE, FALSE
    *   - border_left_style     - left border style, values: 'thin', 'thick', 'double'
    *   - border_left_color     - left border color in hex, example green = 00FF00
    *   - border_right          - show cell right border, values: TRUE, FALSE
    *   - border_right_style    - right border style, values: 'thin', 'thick', 'double'
    *   - border_right_color    - right border color in hex, example green = 00FF00
    *   - border                - show all cell borders, values: TRUE, FALSE
    *   - border_style          - all cell borders style, values: 'thin', 'thick', 'double'
    *   - border_color          - all cell borders color in hex, example green = 00FF00
    *   - wrap_text             - wrap text within cell, values: TRUE, FALSE
    *   - format                - format mas for cell
    *   - rotate_text_degree    - degree number for text rotation, values from 0 to 360
    *   - indent_left           - number of indents from left side, values: number greather than zero
    *   - indent_right          - Number of indents from right side, values: number greather than zero
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/            
    PROCEDURE add_style (style_name VARCHAR2,
                         font_name VARCHAR2 DEFAULT NULL,
                         font_size PLS_INTEGER DEFAULT NULL,
                         formula VARCHAR2 DEFAULT NULL,
                         bold BOOLEAN DEFAULT FALSE,
                         italic BOOLEAN DEFAULT FALSE,
                         underline BOOLEAN DEFAULT FALSE,
                         color VARCHAR2 DEFAULT NULL,
                         bg_color VARCHAR2 DEFAULT NULL,
                         horizontal_align VARCHAR2 DEFAULT NULL,
                         vertical_align VARCHAR2 DEFAULT NULL,
                         border_top BOOLEAN DEFAULT FALSE,
                         border_top_style VARCHAR2 DEFAULT NULL,
                         border_top_color VARCHAR2 DEFAULT NULL,
                         border_bottom BOOLEAN DEFAULT FALSE,
                         border_bottom_style VARCHAR2 DEFAULT NULL,
                         border_bottom_color VARCHAR2 DEFAULT NULL,
                         border_left BOOLEAN DEFAULT FALSE,
                         border_left_style VARCHAR2 DEFAULT NULL,
                         border_left_color VARCHAR2 DEFAULT NULL,
                         border_right BOOLEAN DEFAULT FALSE,
                         border_right_style VARCHAR2 DEFAULT NULL,
                         border_right_color VARCHAR2 DEFAULT NULL,
                         border BOOLEAN DEFAULT NULL,
                         border_style VARCHAR2 DEFAULT NULL,
                         border_color VARCHAR2 DEFAULT NULL,
                         wrap_text BOOLEAN DEFAULT FALSE,
                         format VARCHAR2 DEFAULT NULL,
                         rotate_text_degree INTEGER DEFAULT NULL,
                         indent_left INTEGER DEFAULT NULL,
                         indent_right INTEGER DEFAULT NULL,
                         doc_id PLS_INTEGER DEFAULT current_doc_id);
        
    /***************************************************************************
    * Description: Appliest predefined style to cell
    *
    * Input Parameters:
    *   - cell_name  - name of cell, example 'A'
    *   - style_name - name of style defined with procedure add_style
    *   - doc_id     - unique identificator of document
    *   - sheet_id   - unique identificator of sheet
    *   - row_id     - unique identificator of row
    *
    * Output Parameters: 
    *   - no output parameters
    *
    * Returns:
    *   - does not return anything
    *
    ****************************************************************************/      
                     
    PROCEDURE set_cell_style(cell_name VARCHAR2, 
                             style_name VARCHAR2, 
                             doc_id PLS_INTEGER DEFAULT current_doc_id,
                             sheet_id PLS_INTEGER DEFAULT current_sheet_id,
                             row_id PLS_INTEGER DEFAULT current_row_id);                                                  
                                                                                                                           
END ORA_EXCEL;
/

CREATE OR REPLACE PACKAGE BODY ORA_EXCEL wrapped 
a000000
b2
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
abcd
b
2b5f5 7819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/
